import { Cache } from 'apollo-cache';
import { ApolloReducerConfig, InMemoryCache, NormalizedCacheObject } from 'apollo-cache-inmemory';
import { Store } from 'redux';
export declare type ReduxCacheConfig = ApolloReducerConfig & {
    reduxRootSelector?: string;
};
export declare class ReduxCache extends InMemoryCache {
    private store;
    private reduxRootSelector;
    constructor(config?: ReduxCacheConfig, store?: Store<any>);
    restore(data: NormalizedCacheObject): this;
    extract(optimistic?: boolean): NormalizedCacheObject;
    read<T>(query: Cache.ReadOptions): T | null;
    write(write: Cache.WriteOptions): void;
    evict(query: Cache.EvictOptions): Cache.EvictionResult;
    reset(): Promise<void>;
    private getReducer();
}
